VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} UGoogle 
   Caption         =   "CreateAppointment"
   ClientHeight    =   3165
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   5490
   OleObjectBlob   =   "UGoogle.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "UGoogle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private mbUserCancel As Boolean
Private msLocation As String
Private mdtWhen As Date
Private msWhat As String
Private mdDuration As Double
Private mdtDay As Date

Public Property Let UserCancel(ByVal bUserCancel As Boolean): mbUserCancel = bUserCancel: End Property
Public Property Get UserCancel() As Boolean: UserCancel = mbUserCancel: End Property
Public Property Let Day(ByVal dtDay As Date): mdtDay = dtDay: End Property
Public Property Get Day() As Date: Day = mdtDay: End Property
Public Property Let Location(ByVal sLocation As String): msLocation = sLocation: End Property
Public Property Get Location() As String: Location = msLocation: End Property
Public Property Let When(ByVal dtWhen As Date): mdtWhen = dtWhen: End Property
Public Property Get When() As Date: When = mdtWhen: End Property
Public Property Let What(ByVal sWhat As String): msWhat = sWhat: End Property
Public Property Get What() As String: What = msWhat: End Property
Public Property Let Duration(ByVal dDuration As Double): mdDuration = dDuration: End Property
Public Property Get Duration() As Double: Duration = mdDuration: End Property

Private Sub cmdCancel_Click()
    
    Me.UserCancel = True
    Me.Hide
    
End Sub

Private Sub cmdOK_Click()
    
    Me.UserCancel = False
    Me.Hide
    
End Sub

Private Sub tbxNarrative_Change()
        
    Dim rxNarrative As VBScript_RegExp_55.RegExp
    Dim rxMatches As VBScript_RegExp_55.MatchCollection
    Dim dtTimeEntered As Date
    Dim sMeridian As String
    
    Set rxNarrative = New VBScript_RegExp_55.RegExp
    rxNarrative.Pattern = RegExPattern
    rxNarrative.IgnoreCase = True
    
    Me.lbxAppointment.Clear
    If rxNarrative.test(Me.tbxNarrative.Text) Then
        Set rxMatches = rxNarrative.Execute(Me.tbxNarrative.Text)
        With rxMatches.Item(0) 'there's only one match, all the capture groups are submatches of it
            
            'Get AM or PM
            sMeridian = GetAMPM(.SubMatches(0), .SubMatches(1))
            dtTimeEntered = ConvertStringToTime(.SubMatches(0), sMeridian)
            
            'Account for time zones
            Me.When = Me.Day + ConvertTimeToLocal(dtTimeEntered, .SubMatches(2))
            Me.What = .SubMatches(3)
            
            'Default to 1 hour duration if not entered
            If Len(.SubMatches(5)) > 0 Then
                Me.Duration = Val(.SubMatches(5))
            Else
                Me.Duration = 1 'hour
            End If
        
            If Len(.SubMatches(4)) > 0 Then
                Me.Location = .SubMatches(4)
            End If
            
        End With
        
        Me.tbxNarrative.BackColor = vbWhite
    Else
        Me.tbxNarrative.BackColor = vbYellow 'visual indicator that narrative doesn't work
    End If
    
    'Show the results
    UpdateListbox
    
End Sub

Private Sub UpdateListbox()
    
    Me.lbxAppointment.AddItem "What: " & Me.What
    Me.lbxAppointment.AddItem "Where: " & Me.Location
    Me.lbxAppointment.AddItem "Starts at: " & Format(Me.When, "m/d/yyyy hh:mm")
    Me.lbxAppointment.AddItem "Ends at: " & Format(Me.EndTime, "m/d/yyyy hh:mm")
    
End Sub

Public Property Get EndTime() As Date
    
    EndTime = Me.When + TimeSerial(Int(Me.Duration), (Me.Duration - Int(Me.Duration)) * 60, 0)
    
End Property

Private Function RegExPattern() As String
    
    Dim aPattern(1 To 11) As String
    
    aPattern(1) = "^((?:1[0-2]|0?[1-9])(?::[0-5]\d)?)" 'time
    aPattern(2) = "\s*" 'optional white space
    aPattern(3) = "([ap]m)?" 'optional ampm
    aPattern(4) = "\s*"
    aPattern(5) = "([ECMP][DS]T)?" 'optional time zone
    aPattern(6) = "\s*"
    aPattern(7) = "(.*?" 'what
    aPattern(8) = "(?=\s+for\s+|\s+at\s+|$))" 'look ahead for ' for ' or ' at '
    aPattern(9) = "(?:\s+at\s+(.*?" 'where
    aPattern(10) = "(?=\s+for\s+|$)))?" 'look ahead for ' for '
    aPattern(11) = "(?:\s+for\s+(\d*(?:\.\d+)?)\s*hour)?" 'duration
    
    RegExPattern = Join(aPattern, vbNullString)
    
End Function

Private Function GetAMPM(ByVal sTime As String, ByVal sAmpm As String) As String
    
    Dim sReturn As String
    Dim dtTime As Date
    
    If Len(sAmpm) > 0 Then
        sReturn = sAmpm
    Else
        dtTime = ConvertStringToTime(sTime, "AM")
        If dtTime >= TimeSerial(7, 0, 0) And dtTime < TimeSerial(12, 0, 0) Then
            sReturn = "AM"
        Else
            sReturn = "PM"
        End If
    End If
    
    GetAMPM = sReturn
    
End Function

Private Function ConvertStringToTime(sTime As String, sMeridian As String) As Date
    
    If InStr(1, sTime, ":") = 0 Then
        ConvertStringToTime = TimeValue(sTime & ":00" & Space(1) & sMeridian)
    Else
        ConvertStringToTime = TimeValue(sTime & Space(1) & sMeridian)
    End If
            
End Function

Public Sub Initialize()
    
    If Me.When <> 0 Then
        Me.tbxNarrative.Text = Format(Me.When, "h:mm am/pm") & Space(1)
    End If
    
End Sub

